#include <creaImageIOSystem.h>
#include <creaWx.h>
#include <creaImageIOWxGimmickReaderDialog.h>

#include <creaVtkBasicSlicer.h>

class myApp : public wxApp
{
public:
  bool OnInit( );
  int  OnExit() { return true; }
};

IMPLEMENT_APP(myApp);

CREA_WXMAIN_WITH_CONSOLE

bool myApp::OnInit( )
{
  wxApp::OnInit();
#ifdef __WXGTK__
  //See http://www.wxwindows.org/faqgtk.htm#locale
  setlocale(LC_NUMERIC, "C");
#endif
   wxInitAllImageHandlers();

   creaImageIO::SetGimmickMessageLevel(5);
   creaImageIO::SetGimmickDebugMessageLevel(0);

   int min_dim = GIMMICK_2D_IMAGE_SELECTION;
   int max_dim = GIMMICK_3D_IMAGE_SELECTION;

//EED
//   int output_dim = NATIVE;
   int output_dim = _3D;

   int threads = 1;

   creaImageIO::WxGimmickReaderDialog w(
                    0,
                   -1, 
				   "localdatabase_Descriptor.dscp",
				   "Local Database",
                   _T("Select image(s)        - Gimmick! (c) CREATIS-LRMN 2008"),
                   wxDefaultPosition,
                   wxSize(810,750),
                   min_dim,
                   max_dim,
                   output_dim,
                   threads);
   w.ShowModal();

   if (w.GetReturnCode() == wxID_OK)
     {
       std::cout << "$$$$ main : user clicked 'OK' $$$$"<<std::endl;
       std::cout << "$$$$ selected files : "<<std::endl;
       //Puts filenames
       std::vector<std::string> s;
       w.GetSelectedFiles(s);
       std::vector<std::string>::iterator i;
       for (i=s.begin();i!=s.end();++i) 
         {
           std::cout << *i << std::endl;
         }
       std::cout << "$$$$ "<<std::endl;

       //Puts images
       std::vector<vtkImageData*> images;
       w.GetSelectedImages(images,output_dim);
       std::cout<<images.size()<<std::endl;

       crea::VtkBasicSlicer(images.front());
       images.front()->Delete();
       w.OnExit();

     }
   else if (w.GetReturnCode() == wxID_CANCEL)
     {
       w.OnExit();
       std::cout << "$$$$ main : user clicked 'CANCEL' $$$$"<<std::endl;
     }
   else 
     {
       w.OnExit();
       std::cout << "$$$$ main : dialog ended without return code ! $$$$"
                 <<std::endl;    
     }

   //   std::cout << "$$$$ main : deleting dialog"<<std::endl;
   //   delete w;
   std::cout << "$$$$$$$$$$$$$$$$$$$$ main ended "<<std::endl;
   return false;
}


