#ifndef __creaImageIOField_h_INCLUDED__
#define __creaImageIOField_h_INCLUDED__

#include <string>
#include <iostream>
namespace creaImageIO
{


  //=====================================================================
  namespace Field
  {

    typedef std::string Key;

    struct Description
    {      
      Description()
	: key(""), group(0), element(0), name(""), flags(0)
      {
      }
      Description(const std::string& k,
		  unsigned short g,
		  unsigned short e,
		  const std::string& n,
		  unsigned int f)
	: key(k), group(g), element(e), name(n), flags(f) 
      {}
      const std::string& GetKey() const { return key; }
      unsigned short GetGroup() const { return group; }
      unsigned short GetElement() const { return element; }
      const std::string& GetName() const { return name; }
      unsigned int GetFlags() const { return flags; }
      
      std::string key;
      unsigned short group;
      unsigned short element;
      std::string name;
      unsigned int flags;
    };

    typedef std::string Value;

  } // namespace Field
  //=====================================================================


} // namespace creaImageIO



  //=====================================================================
inline std::ostream& operator<<(std::ostream& s, const creaImageIO::Field::Description& d)
{
  s << "[" << d.key << ":" << d.name << "]";
  return s;
}
//=====================================================================



#endif // #ifndef __creaImageIOField_h_INCLUDED__
