#ifndef __creaImageIOWxGimmickDialog_h_INCLUDED__
#define __creaImageIOWxGimmickDialog_h_INCLUDED__

#include <creaImageIOSystem.h>
#include <creaImageIOWxGimmick.h>

namespace creaImageIO
{


  //=====================================================================
  class CREAIMAGEIO_EXPORT WxGimmickDialog : public wxDialog
  {
  public:
    WxGimmickDialog();    
    WxGimmickDialog(wxWindow *parent, 
		    const wxWindowID id,
		    wxString title,
		    const wxPoint& pos, 
		    const wxSize& size,
		    int image_type = GIMMICK_3D_IMAGE_SELECTION,
		    int threads = 0);
    
    typedef WxGimmick ViewType;
    typedef WxGimmick::EventType EventType;

    ~WxGimmickDialog();

    void GetSelectedImages(std::vector<vtkImageData*>& s)
    { mView->GetSelectedImages(s); }
    void GetSelectedFiles(std::vector<std::string>& s) 
    { mView->GetSelectedFiles(s); }
    
    void OnSelChanged(EventType& event);
    void OnContextualMenu(EventType& event);
    void OnMenuTest(wxCommandEvent& event);
    //    void OnButtonOk(wxCommandEvent& event);
    //    void OnButtonCancel(wxCommandEvent& event);

    DECLARE_EVENT_TABLE();
  private :
    
    ViewType* mView;

    wxButton* mOkButton;
    wxButton* mCancelButton;

    enum 
      {
	TVID = 1
	//	OKID = 2,
	//	CANCELID = 3
      };

  }; // class WxGimmickDialog
  //=====================================================================


} // namespace creaImageIO



#endif // #ifndef __creaImageIOWxGimmickDialog_h_INCLUDED__
