#ifndef __creaImageIOWxAttributeSelectionPanel_h_INCLUDED__
#define __creaImageIOWxAttributeSelectionPanel_h_INCLUDED__

#ifdef USE_WXWIDGETS
#include <creaWx.h>
#include <creaImageIOWxGimmickView.h>
#include <wx/listctrl.h>


namespace creaImageIO
{
  /**
   * \ingroup GUI
   */
  //=====================================================================
 //=====================================================================
  class WxAttributeSelectionPanel : public wxPanel
  {
  public:
    WxAttributeSelectionPanel();    
	WxAttributeSelectionPanel(wxWindow *parent, 
		wxDialog* dial,
		WxGimmickView* view,
		std::vector<std::string> sAtts,
	    std::vector<std::string> nsAtts,
		int numLev);
    
    ~WxAttributeSelectionPanel();
	///Saves the configuration
	 void OnSaveConfig(wxCommandEvent& event);
	 ///Changes items from shown to notShown
	 void OnAdd(wxCommandEvent& event);
	 ///Changes items from notShown to shown
	 void OnRemove(wxCommandEvent& event);
	 void OnComboChange(wxCommandEvent& event);
  

  private :
	  ///Loads the information on the vectors onto the lists
	   void LoadCtrls();
	  std::vector<std::string> shownA;
	  std::vector<std::string> notShownA;
	  wxComboBox* levels;
	  wxListCtrl* shownAtts;
	  wxListCtrl* notShownAtts;
	wxDialog* dialog;
	WxGimmickView* mView;

	
	DECLARE_EVENT_TABLE()

  }; // class WxAttributeSelectionPanel
  //=====================================================================

  
} // EO namespace creaImageIO


#endif // USE_WIDGETS
// EOF
#endif

