#ifndef __creaImageIOWxGimmickReaderDialog_h_INCLUDED__
#define __creaImageIOWxGimmickReaderDialog_h_INCLUDED__

#ifdef USE_WXWIDGETS

#include <creaImageIOWxGimmickView.h>
#include <creaWx.h>
#include "wx/wx.h"
namespace creaImageIO
{
  /**
   * \ingroup GUI
   */

  //=====================================================================
 //=====================================================================
  class CREAIMAGEIO_EXPORT  WxGimmickReaderDialog : public wxDialog
  {
  public:
    WxGimmickReaderDialog();
    WxGimmickReaderDialog(wxWindow *parent,
			  const wxWindowID id,
			  const std::string i_namedescp , 
			  const std::string i_namedb ,
			  wxString title,
			  const wxPoint& pos,
			  const wxSize& size,
			  int image_min_dim = GIMMICK_2D_IMAGE_SELECTION,
			  int image_max_dim = GIMMICK_3D_IMAGE_SELECTION,
			  int output_dim = NATIVE,
			  int threads = 0);

    boost::shared_ptr<Gimmick> GetGimmick() { return mGimmick; }
    //    typedef WxGimmick ViewType;
    typedef WxGimmickView::EventType EventType;

    ~WxGimmickReaderDialog();

	//===============================================================================================
	//Image Selection
	//===============================================================================================

    void GetSelectedImages(std::vector<vtkImageData*>& s, int dim)
    { mView->GetSelectedImages(s, dim); }

    void GetSelectedImagesInVector(std::vector<vtkImageData*>& s, int dim)
    { mView->GetSelectedImagesInVector(s, dim); }

    void GetSelectedFiles(std::vector<std::string>& s) 
    { mView->GetSelectedFiles(s); }

    void OnSelChanged(EventType& event);
    void OnContextualMenu(EventType& event);
    void OnMenuTest(wxCommandEvent& event);
    void OnValid(bool valid);
    void OnExit(){ mView->StopPlayer(); }
    // void OnButtonOk(wxCommandEvent& event);
    // void OnButtonCancel(wxCommandEvent& event);

  private :

    boost::shared_ptr<Gimmick>   mGimmick;
    WxGimmickView* mView;

    wxButton* mOkButton;
    wxButton* mCancelButton;
	wxBoxSizer *mtopsizer;

    enum 
      {
	TVID = 1
	//	OKID = 2,
	//	CANCELID = 3
      };

  }; // class WxGimmickReaderDialog
  //=====================================================================
	
} // EO namespace creaImageIO


#endif // USE_WIDGETS
// EOF
#endif  
