#include <creaImageIOWxPACSConnectionPanel.h>
#include <creaImageIOPACSConnection.h>
#include <creaImageIOSystem.h>

namespace creaImageIO
{
  // CTor
  WxPACSConnectionPanel::WxPACSConnectionPanel(wxWindow *parent, wxDialog* dial, WxGimmickView* view)
 :   wxPanel( parent, 
		  -1, wxDefaultPosition, 
		  wxDefaultSize,
		  wxRESIZE_BORDER | 
	      wxSYSTEM_MENU  |
		  wxCLOSE_BOX |
		  wxMAXIMIZE_BOX | 
		  wxMINIMIZE_BOX | 
		  wxCAPTION  
	       ), 	
		   dialog(dial),
		   mView(view)
  {
    GimmickDebugMessage(1,"WxPACSConnectionPanel::WxPACSConnectionPanel"
			<<std::endl);
	wxStaticText * dicId=new wxStaticText(this,-1,_T(" DICOM Identification: "), wxPoint(5,5));
	wxStaticText * aet=new wxStaticText(this,-1,_T(" AETitle: "), wxPoint(5,25));
	aeTitle=new wxTextCtrl(this, wxID_ANY, _T("MyAeTitle"), wxPoint(75,25), wxSize(220,20));

	wxStaticText * pn=new wxStaticText(this,-1,_T(" Port Number: "), wxPoint(5,53));
	pNumber=new wxTextCtrl(this, wxID_ANY, _T("3306"), wxPoint(75,50), wxSize(220,20));
	wxStaticText * adv1=new wxStaticText(this,-1,_T(" (1 - 131072) "), wxPoint(300,53));

	wxStaticText * ad=new wxStaticText(this,-1,_T(" Address: "), wxPoint(5,80));
	address=new wxTextCtrl(this, wxID_ANY, _T("localhost"), wxPoint(75,75), wxSize(220,20));
	
	wxButton *query = new wxButton(this,wxID_ANY,_T("Query PACS Server"), wxPoint(5,110) );
	Connect( query->GetId(), wxEVT_COMMAND_BUTTON_CLICKED , (wxObjectEventFunction) &WxPACSConnectionPanel::OnQueryPACS ); 
   
    Layout(); 
  }

  /// Destructor
  WxPACSConnectionPanel::~WxPACSConnectionPanel()
  {
    GimmickDebugMessage(1,"WxPACSConnectionPanel::~WxPACSConnectionPanel"
			<<std::endl);
  }

  void WxPACSConnectionPanel::OnQueryPACS(wxCommandEvent& event)
  {
	  PACSConnection* pc=new PACSConnection(crea::wx2std(aeTitle->GetValue()));
	  //mView->OnListenerCallback(crea::wx2std(drives->GetValue()),addFiles, removeFiles);
	  //dialog->Destroy();
  }
  
//======================================================================
  
//====================================================================== 

} // EO namespace creaImageIO


